From 7238e8d11694d72ab7e49b122f59b915d0e2e8ad Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 27 2021 05:04:27 +0000
Subject: [PATCH 2218/2232] Add test of passing by alias type by pin mut ref


---

diff --git a/tests/ffi/module.rs b/tests/ffi/module.rs
index cd9fc2b..089a5c5 100644
--- a/tests/ffi/module.rs
+++ b/tests/ffi/module.rs
@@ -32,6 +32,9 @@ pub mod ffi2 {
 
         fn c_take_trivial_ptr(d: UniquePtr<D>);
         fn c_take_trivial_ref(d: &D);
+        fn c_take_trivial_mut_ref(d: &mut D);
+        fn c_take_trivial_pin_ref(d: Pin<&D>);
+        fn c_take_trivial_pin_mut_ref(d: Pin<&mut D>);
         fn c_take_trivial_ref_method(self: &D);
         fn c_take_trivial_mut_ref_method(self: &mut D);
         fn c_take_trivial(d: D);
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index 831097d..a4d8c47 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -604,6 +604,18 @@ void c_take_trivial_ref(const D &d) {
   }
 }
 
+void c_take_trivial_mut_ref(D &d) {
+  (void)d;
+}
+
+void c_take_trivial_pin_ref(const D &d) {
+  (void)d;
+}
+
+void c_take_trivial_pin_mut_ref(D &d) {
+  (void)d;
+}
+
 void D::c_take_trivial_ref_method() const {
   if (d == 30) {
     cxx_test_suite_set_correct();
diff --git a/tests/ffi/tests.h b/tests/ffi/tests.h
index eaa4361..a5d8bc0 100644
--- a/tests/ffi/tests.h
+++ b/tests/ffi/tests.h
@@ -184,6 +184,9 @@ size_t c_get_use_count(const std::weak_ptr<C> &weak) noexcept;
 
 void c_take_trivial_ptr(std::unique_ptr<D> d);
 void c_take_trivial_ref(const D &d);
+void c_take_trivial_mut_ref(D &d);
+void c_take_trivial_pin_ref(const D &d);
+void c_take_trivial_pin_mut_ref(D &d);
 void c_take_trivial(D d);
 
 void c_take_trivial_ns_ptr(std::unique_ptr<::G::G> g);

